Tento modul zce souvis s~modulem \vizmod [color]. Zakld datov typ
\dg kq_map.

Je to dvourozmrn pole ukazatel na \cite barvu[m:color], 
kter obsahuje zrove
informaci o~svch rozmrech (poloky "sirka" a "vyska"). Ve
skutenosti je pole uloeno jako jednorozmrn kvli usnadnn prce
s~pamt. Jednotliv \cite barvy[m:color] jsou do tohoto pole do poloky "pole"
ukldny po dcch. Struktura "kq_map" bv pouvna pmo, tedy ne
jako ukazatel. Ze souadnic vrt pslunou \cite barvu[m:color] funkce
\dg [kq_color *]mappixel().

\insf mappixel

Struktura "kq_map" je zaloena z~XPM souboru funkc \dg [kq_map]
nactimapu(). Tato funkce pi ten souboru nejprve do nalezench barev
piad pslun znak a potom hled, kter \cite barva[m:color] onen znak m.

\insf nactimapu

Pro alokaci sprvn velkho pole pouvm funkci allocpole. Pvodn bylo
pole barev skuten dvourozmrn, take byla tato funkce
sloitj. Nyn jen zavol "malloc".

\insf allocpole

\subsec submap

Ve he je hlavn mapa uloen v~promnn \dg [kq_map] mapa. Tato mapa
vak nen generovna ze souboru, ale z~ostatnch natench
map.

\ifirst {map.h}{mapa}{}{++}

Ostatn mapy maj jet daj o~souadnicch, kde se na hlavn map
vyskytuj. Takovm mapm km submapy a jsou datovm typem \dg
kq_submap.

\inst kq_submap

Poloky "x", "y", "z" uruj souadnice submapy. X-ov souadnice
udv, o~kolik polek je submapa posunuta doprava a Y-ov souadnice
udv, o~kolik polek je submapa posunuta dol. Z-kov souadnice
funguje podobn jako u~widget, tedy m m submapa vy Z-kovou
souadnici, tm je bl, tedy tm sp se promtne do hlavn mapy.
U~map je vak Z-kov souadnice stna se Z-kovou souadnic
\cite barvy[m:color].

Pklad: Bl m Z-kovou souadnici 0 a ern a lut m Z-kovou
souadnici 2. Mm celou ernou submapu se Z-kovou souadnic 0. Nad n
je submapa jej "z=1" a obsahuje blou a lutou barvu. Do hlavn mapy
se tak promtne to, co bylo v~druh submap lut, zbytek je ern.

Pro efektivnj prci se Z-kovmi souadnicemi submap a barev mm
pole \dg [float *]mapa_z, kter nen soust jin struktury, ale pat k~hlavn
map. Toto pole vak nen polem barev, ale Z-kovch souadnic. Pro
kad polko v~map tedy obsahuje informaci, jakou Z-kovou souadnici
m pslun polko, tedy souet Z-kovch souadnic barvy a
submapy. Krom toho funguje "mapa_z" jako ukazatel, zda existuje
mapa, pokud mapa nen, tak "mapa_z = NULL".

\ifirst {map.c}{mapa_z}{}{++}

Specifickou submapou je \dg [kq_submap] bg_map, se kterou
nefunguj operace s~bnmi submapami a uruje samotnou mapu. Tedy je
na souadnicch 0, 0, 0 a podle jejch rozmr jsou ureny i rozmry
hlavn mapy.

\ifirst {map.c}{bgmap}{}{++}

Pro zmnu "bgmap" je pipravena funkce \dg [void] zmenbgmap(). Tato
funkce dostane nzev souboru, ze kterho m pest novou
submapu. Pokud je tento nzev "NULL", je "bgmap", tedy i "mapa",
zruena.

\insf zmenbgmap

Funkce \dg [kq_submap *]vytvorsubmap() zalo jinou submapu ne
"bgmap". Ped submap
sv parametry a vrt jej ukazatel.

\insf vytvorsubmap

Funkce \dg [void] znicsubmap() submapu odstran a uvoln z~pamti.

\insf znicsubmap

Tato funkce vyuv funkci \dl [void] freesm(), kter submapu jen
uvoln z~pamti.

\insf freesm

Submapy jsou polokou "next" azeny do seznamu zanajcho submapou
\dg [kq_submap *]prvsubmap.

\ifirst {map.h}{prvsubmap}{}{++}

Stejn jako v~ppad widget je "prvsubmap" submapa s~nejvy
Z-kovou souadnic. Dle jsou submapy seazeny sestupn podle tto
souadnice. Funkce \dl [void] zaradsubmap() zaad submapu do
sprvnho msta seznamu. Ukazatel na seznam, do kterho m submapu
zaadit je pedn v~parametru.

\insf zaradsubmap

Funkce \dl [void] vyradsubmap() vyad submapu ze seznamu. Ukazatel na
seznam je j pedn v~parametru stejn jako u~funkce "zaradsubmap".

\insf vyradsubmap

Promtn submap do mapy ovem nen tak jednoduch, jak to zatm
vypad. Okamit prava hlavn mapy je provedena pouze v~ppad, e
je promnn \dg [char] autoreloadmap nastavena na true. Po nastaven
tto hodnoty na true je vhodn spustit funkci \dg [void] reloadmap(),
kter pepot celou hlavn mapu. Udl to tak, e nejprve do hlavn
mapy zkopruje "bgmap" a potom prochz ostatn submapy a promtne je
do hlavn mapy funkc "pouzijsubmap". Nen vak vhodn nechvat v~map
nco jinho, ne v~n m bt, protoe se "mapa" neukld do souboru.

\ifirst {map.c}{autoreloadmap}{}{++}

\insf reloadmap

Funkce \dl [void] pouzijmapu() dostane submapu, kterou zkopruje do
sprvn sti hlavn mapy. Ovem pouze tam, kde je souet Z-kov
souadnice submapy a barvy vy ne pslun polko v~"mapa_z".

\insf pouzijsubmap

Tato funce pouv tyi lokln promnn: "x", "y", "sx", "sy". Tyto
promnn jsou synchronisovny tak, aby "mapa.pole[x+y]" ukazovalo na stejn
polko jako "sm->map.pole[sx+sy]". Y-ov souadnice je vdy nsobkem
ky mapy a X-ov je men ne ka mapy.

Podobn funguje funkce \dl [void] zrussubmap(), kter v~mstech hlavn
mapy, kter se shoduj s~pslunm polkem pidan submapy, vyhled
v~seznamu submap vhodnou nhradu.

\insf zrussubmap

Funkce \dg [kq_submap *]nejvyssipix() najde submapu, kter m na
danch souadnicch polko s~nejvt Z-kovou souadic. Tuto funkci
vyuv i funkce "zrussubmap", take je teba nejprve submapu vyadit
ze seznamu a pak teprve ji zruit.

\insf nejvyssipix

Funkce \dg [kq_color *]smpixel() vrt polko submapy podle souadnic
hlavn mapy.

\insf smpixel

Funkce \dg [kq_submap *]najdibarvu() vrt nejvy submapu, kter
obsahuje uritou barvu na danch souadnicch hlavn mapy.

\insf najdibarvu

Ve struktue "kq_submap" je tak poloka "hide", kter stejn jako
u~widget uruje, zda je submapa schovan. Schovan submapy (hide = 1)
nejsou v~seznamu "prvsubmap", ale v~seznamu
\dg [kq_submap *]prvhidsm. To je dvod, pro funkce "zaradsubmap" a
"vyradsubmap" maj parametr, kter seznam maj pout. Schovan
submapy nejsou v~map, ale je mon narozdl o~zobrazench submap jim
mnit souadnice.

Funkce \dg [void] hidesubmap() schov submapu.

\insf hidesubmap

Funkce \dg [void] unhidesubmap() odschov submapu.

\insf unhidesubmap

Funkce \dg [void] deletelsubmaps() smae vechny submapy, kter maj
kladnou poloku "lokalni" a schov ty, kter maj poloku "lokalni"
zpornou. Beze zmny tedy zstanou jen ty, kde je poloka "lokalni"
nulov. Tato funkce je sputna pi pechodu na jin polko.

\insf deletelsubmaps

Funkce \dg [void] deleteAsubmaps() smae vechny submapy. Je zavolna
pi naten pozice nebo pi restartu.

\insf deleteAsubmaps

Zpsob, jak chpat hlavn mapu na obrzku je dn promnnmi \dg [int]
map_xa, \dg [int] map_xb, \dg [int] map_ya, \dg [int] map_yb. Polko
mapy, kter m souadnice "x", "y", m na obrzku (ve "win") souadnice:
$$"x*map_xa+map_xb",\quad"y*map_ya+map_yb".$$
