#include "kraluk.h"

void start_jp (kq_policko *opol, int smer, kq_policko *npol)
{
  if(rand()%2 && npol != pol[4][1]) return;

  kq_animpost *anip;
  int x, y, cas;
  void (*auto_func)(kq_postava *post);

  auto_func = auto_random;
  if(npol == pol[7][0]){
    if(makozisek) return;
    cas = 50;
    anip = nactianip(9, 40, "shvezdou", 4, 0, 0, 0, 1);
    x = 0; y = 90;
  }
  else if(npol == pol[3][6]){
    if(dostalkyt) return;
    cas = 50;
    anip = nactianip(9, 40, "maruska", 4, 0, 0, 0, 1);
    x = 0; y = 90;
  }
  else if(npol == pol[6][6]){
    if(dostalsvic) return;
    cas = 0;
    auto_func = pysna_random;
    anip = nactianip(8, 45, "pysna", 1, 0, 0, 0, 1);
    x = 16; y = 94;
  }
  else{
    cas = 0;
    anip = nactianip(9, 42, "lotrando", 4, 0, 0, 0, 1);
    x = 21; y = 93;
  }

  jinapost = vytvorpost(x, y, VPRAVO, 3, -1, 1, cas);
  jinapost->free_func = null_jp;
  jinapost->zdi = 1;
  jinapost->odraz = 1;
  jinapost->barvy = 0;
  jinapost->chyt_vzdal = 9;
  jinapost->chyt_func = chyt_jp;
  setchytpost(jinapost, panacek);
  jinapost->xx = 1;
  jinapost->yy = -1;
  normal_z(jinapost, NULL, NULL);
  zmenanip(jinapost, anip);
  if(npol == pol[4][1]) autopost(jinapost, auto_clever, 0, 0);
  else autopost(jinapost, auto_func, 100, 20);
  post_submap(jinapost, "jinapost", 16, 16, 5);
  if(cas) vytvortimer(objev_jp, pinnull, cas, -1, 1, 1, 0);
  else objev_jp();
}

void objev_jp ()
{
  if(post_vzdal(jinapost, panacek) > 9){
    osoba->kontext++;
    if(aktupol != pol[4][1]){
      znak = 'p';
      divka->kontext++;
      princezna->slovo->kontext++;
      if(aktupol == pol[7][0]) lada->kontext++;
      if(aktupol == pol[3][6]) maruska->kontext++;
      if(aktupol == pol[6][6]) krasomila->kontext++;
    }
    else{
      lotrando->kontext++;
      muz->kontext++;
    }
    unhidepost(jinapost);
  }
}

void chyt_jp ()
{
  if(jinapost->autou_typ == AUTOU_SOUR){
    vytvortimer(znicpost, pinpointer(jinapost), 0, 100, 1, 0, 0);
    return;
  }
  if(jinapost->tim) pausetimer(jinapost->tim);
  if(jinapost->auto_tim) pausetimer(jinapost->auto_tim);
  if(aktupol == pol[4][1]) popup_info("lotrando");
  if(aktupol == pol[6][6]) popup_info("pysna");
  vytvortimer(continue_jp, pinnull, 20, -1, -1, 1, 0);
}

void continue_jp ()
{
  if(!jinapost){
    znictimer(aktutimer);
    return;
  }
  if(post_vzdal(jinapost, panacek) > 9){
    znictimer(aktutimer);
    if(jinapost->auto_tim) unpausetimer(jinapost->auto_tim);
    if(jinapost->tim) unpausetimer(jinapost->tim);
  }
}

void pysna_random (kq_postava *post)
{
  int smer;

  if(post->y >= 104) smer = rand()%5;
  else smer = rand()%8;

  if(smer > 3) smer++;

  post->xx = smer%3-1;
  post->yy = smer/3-1;
}

void null_jp (kq_postava *post)
{
  jinapost = NULL;
  if(post->hide) return;

  if(aktupol != pol[2][2]) osoba->kontext--;
  if(aktupol == pol[7][0] || aktupol == pol[3][6] || aktupol == pol[6][6]){
    znak = 0;
    divka->kontext--;
    princezna->slovo->kontext--;
    if(aktupol == pol[7][0]) lada->kontext--;
    if(aktupol == pol[3][6]) maruska->kontext--;
    if(aktupol == pol[6][6]) krasomila->kontext--;
  }
  else if(aktupol == pol[4][1]){
    lotrando->kontext--;
    muz->kontext--;
  }
}
