#include"kraluk.h"

void nastavpolicka ()
{
  pol_odchfunc = nullujznak;

  pol[0][0] = newpol("Mapa0x0", "Plocha0x0", 2,0,1,40);
  pridej_pw( 1, 60, 200, "skala0x0.1"); 
  pridej_pw(33,  0,  12, "skala0x0.2"); 

  pol[1][0] = newpol("Mapa1x0", "Plocha1x0", 2,0,1,40);
  pol[1][0]->odchfunc = opravvodu;
  pridej_pw(0,0,60, "skala1x0");
  pridej_pw(66,47,19, "trava1");
  pridej_pw(76,61,33, "trava2");
  pridej_pw(56,81,53, "trava3");
  pridej_pw(68,99,71, "trava4");
  pridej_pw(64,117,89, "trava5");
      pw_xy(48,135);
  pridej_pw(176,45,17, "trava6");
  pridej_pw(194,56,28, "trava7");
  pridej_pw(180,70,42, "trava8");
  pridej_ps(&voda);

  pol[2][0] = newpol("Mapa2x0", "Plocha2x0", 2,0,1,40);
  pridej_pw(26,4,38, "strom2x0");
  pridej_ps(&strom);
  pridej_ps(&voda);
  pridej_ps(&tresne);

  pol[3][0] = newpol("Mapa3x0", "Plocha3x0", 2,0,1,40);
  pridej_pw(8,109,95, "kytky");
  pridejbarvu("#662B00", 1)->prichfunc = bachakytky;
  pridej_ps(&voda);

  pol[4][0] = newpol("Mapa4x0", "Plocha4x0", 2,0,1,40);
  kq_color *voda4;
  voda4 = pridejbarvu("#2A00FF", 0);
  voda4->prichfunc = plave;
  voda4->odchfunc = sucho;
  pridej_ps(&voda);

  pol[5][0] = newpol("Mapa5x0", "Plocha5x0", 2,0,1,40);
  pridej_pw(18,0,120, "mrak"); 
  kq_color *telebarva;
  telebarva = pridejbarvu("#009543", 0);
  telebarva->prichfunc = &telestart;
  telebarva->odchfunc = &teleend;

  pol[6][0] = newpol("Mapa6x0", "Plocha6x0", 2,0,1,40);
  pridej_pw(16,42,35, "balvan1"); 
  pridej_pw(118,30,25, "balvan2");
  pridej_pw(6,126,116, "balvan3");
  pridej_pw(60,94,90, "balvan4"); 
  pridej_pw(144,80,77, "balvan5"); 

  pol[7][0] = newpol("Mapa7x0", "Plocha7x0", 2,0,1,40);
  pol[7][0]->prichfunc = start_jp;

  pol[0][1] = newpol("Mapa0x1", "Plocha0x1", 2,0,1,40);
  pridej_pw(0,0,1000, "skala0x1");
  pol[0][1]->prichfunc = prichzebr;
  pol[0][1]->odchfunc = odchzebr;

  pol[1][1] = newpol("Mapa1x1", "Plocha1x1", 2,0,1,40);
  pridej_pw(40,14,53, "chaloupka1");
  pridej_pw(99,14,86, "chaloupka2");
  pridej_ps(&dvere);

  pol[2][1] = newpol("Mapa2x1", "Plocha2x1", 2,0,1,40);
  pol[2][1]->prichfunc = prich_jezin;
  pol[2][1]->odchfunc = nullosobu;
  pridej_ps(&smolicek);
  pridej_ps(&jezinky);
  pridej_pw(68,82,63, "parez");

  pol[3][1] = newpol("Mapa3x1", "Plocha3x1", 2,0,1,40);
  pol[3][1]->prichfunc = prich_krk;
  pol[3][1]->odchfunc = null_krk;
  pridej_pw( 95,93,101, "proptaky");
      pw_xy( 62,77);
      pw_xy( 38,59);
      pw_xy( 16,38);
      pw_xy(173,42);
      pw_xy(150,55);
      pw_xy(126,76);
      pridej_ps(&krkavci);

  pol[4][1] = newpol("Mapa4x1", "Plocha4x1", 2,0,1,40);
  pol[4][1]->prichfunc = start_jp;
  pridej_pw(4,17,104, "strom4x1.1"); 
  pridej_pw(164,18,85, "strom4x1.2"); 
  pridej_pw(66,0,35, "strom4x1.3"); 
  pridej_ps(&strom);

  pol[5][1] = newpol("Mapa5x1", "Plocha5x1", 2,0,1,40);
  pol[5][1]->prichfunc = prich_bohd;
  pol[5][1]->odchfunc = odch_bohd;
  pridej_pw(41,16,90, "drevchal"); 
  pridej_pw(82,104,95, "zidle");
  pridej_ps(&dvere);

  pol[6][1] = newpol("Mapa6x1", "Plocha6x1", 2,0,1,40);
  pridej_pw( 12,  40,13, "trava6x1.1");
      pw_xy( 46,  50);
      pw_xy( 79,  45);
      pw_xy(143,  48);
      pw_xy(190,  46);
      pw_xy(116,  63);
      pw_xy( 15,  92);
      pw_xy( 97,  90);
      pw_xy(155,  92);
      pw_xy(195,  98);
      pw_xy( 56, 111);
      pw_xy(181, 119);
      pw_xy( 29, 139);
      pw_xy(136, 142);
  pridej_pw( 15,  71, 44, "trava6x1.2");
      pw_xy( 71,  72);
      pw_xy(167,  65);
      pw_xy( 56,  87);
      pw_xy(125, 107);
      pw_xy( 21, 116);
      pw_xy( 78, 126);
      pw_xy(103, 139);
  pridej_pw(200,88,56, "skala6x1");

  pol[7][1] = newpol("Mapa7x1", "Plocha7x1", 2,0,1,40);
  pridej_pw(0,0,58, "skala7x1"); 

  pol[0][2] = newpol("Mapa0x2", "Plocha0x2", 2,0,1,40);
  pol[0][2]->odchfunc = opravvodu;
  pridej_ps(&voda);

  pol[1][2] = newpol("Mapa1x2", "Plocha1x2", 2,0,1,40);
  pridej_pw( 61,  60, 29, "trava1x2.1");
  pridej_pw(127,  61, 30, "trava1x2.2");
  pridej_pw( 90,  91, 60, "trava1x2.3");
  pridej_pw( 50, 118, 91, "trava1x2.4");
      pw_xy(109, 118);
  pridej_pw( 81, 120, 93, "trava1x2.5");
      pw_xy(134, 118);

  pol[2][2] = newpol("Mapa2x2", "Plocha2x2", 2,0,1,40);
  pol[2][2]->odchfunc = opravvodu;
  pol[2][2]->prichfunc = prich_jelen;
  pridej_ps(&voda);
  pridej_ps(&jelen);

  pol[3][2] = newpol("Mapa3x2", "Plocha3x2", 2,0,1,40);
  pridej_ps(&voda);

  pol[4][2] = newpol("Mapa4x2", "Plocha4x2", 2,0,1,40);
  pridej_pw(141, 39, 25, "ker4x2");
  pridej_ps(&voda);

  pol[5][2] = newpol("Mapa5x2", "Plocha5x2", 2,0,1,40);
  pol[5][2]->odchfunc = opravvodu;
  pridej_ps(&voda);

  pol[6][2] = newpol("Mapa6x2", "Plocha6x2", 2,0,1,40);
  pol[6][2]->odchfunc = opravvodu;
  pridej_pw( 15,  30, 3, "trava1");
      pw_xy(190,  36);
      pw_xy( 51,  43);
      pw_xy( 73, 139);
  pridej_pw( 63,  72, 45, "trava2");
      pw_xy(163,  54);
      pw_xy(102,  84);
      pw_xy( 16,  60);
  pridej_pw(143,  37, 10, "trava3");
      pw_xy( 94,  58);
      pw_xy(130,  54);
  pridej_pw(134,  78, 51, "trava4");
      pw_xy( 11, 109);
      pw_xy( 88,  29);
  pridej_pw( 63, 109, 82, "trava5");
      pw_xy(169,  29);
      pw_xy(102, 116);
  pridej_pw( 33,  89, 62, "trava6");
      pw_xy( 34, 129);
      pw_xy(194,  62);
  pridej_ps(&voda);

  pol[7][2] = newpol("Mapa7x2", "Plocha7x2", 2,0,1,40);
  pridej_ps(&voda);

  pol[0][3] = newpol("Mapa0x3", "Plocha0x3", 2,0,1,40);
  pol[0][3]->odchfunc = opravvodu;
  pridej_ps(&voda);

  pol[1][3] = newpol("Mapa1x3", "Plocha1x3", 2,0,1,40);
  pridej_pw( 90,  5, 101, "strom1x3.1");
  pridej_pw(  6, 13, 103, "strom1x3.2");
  pridej_pw(145,  5,  70, "strom1x3.3");
  pridej_pw( 47,  1,  66, "strom1x3.4");
  pridej_pw(171,  5,  37, "strom1x3.5");
  pridej_pw(126, 16,  49, "strom1x3.6");
  pridej_pw( 83, 13,  46, "strom1x3.7");
  pridej_pw( 38,  5,  32, "strom1x3.8");
  pridej_ps(&strom);

  pol[2][3] = newpol("Mapa2x3", "Plocha2x3", 2,0,1,40);
  pol[2][3]->odchfunc = opravvodu;
  pridej_pw(79, 98, 77, "most");
  most_col = pridejbarvu("#808080", 0);
  most_col->prichfunc = &prich_most;
  most_col->odchfunc = &odch_most;
  pridej_psm(39, 58, 1, "most", 1, &most_sm);
  pridej_ps(&voda);

  pol[3][3] = newpol("Mapa3x3", "Plocha3x3", 2,0,1,40);
  pridej_pw(21, 1, 74, "hrad_l");  

  pol[4][3] = newpol("Mapa4x3", "Plocha4x3", 2,0,1,40);
  pridej_pw( 0, 1, 74, "hrad_p");  
  pridej_pp(27, 74, 0, 0, &dvere_post,
	    0, 0, 74.1,
	    NULL, 12, 10, 0,
	    "dvere_h", 9, 38, 46, 0, 1, 0);
  pridej_ps(&dvere);

  pol[5][3] = newpol("Mapa5x3", "Plocha5x3", 2,0,1,40);
  pol[5][3]->odchfunc = opravvodu;
  pridej_ps(&voda);
  
  pol[6][3] = newpol("Mapa6x3", "Plocha6x3", 2,0,1,40);
  pol[6][3]->odchfunc = opravvodu;
  pridej_ps(&voda);

  pol[7][3] = newpol("Mapa7x3", "Plocha7x3", 2,0,1,40);
  pridej_pw(  7,  14, 85, "sluj_fg");
  pridej_pw( 43,  52, 29, "sluj_bg");
  pridej_pw(135,  74, 62, "bobes");
  pridej_pw( 63, 102,  0, "dira_fg");
  pridej_ps(&bobes);
  pridej_ps(&muz);
  pridej_ps(&osoba);

  pol[0][4] = newpol("Mapa0x4", "Plocha0x4", 2,0,1,40);
  pol[0][4]->odchfunc = opravvodu;
  pridej_pw(94, 63, 54, "ker0x4");
  pridej_ps(&voda);

  pol[1][4] = newpol("Mapa1x4", "Plocha1x4", 2,0,1,40);
  pridej_pw(66, 100, 92, "ker1x4.1");
  pridej_pw(82,  67, 57, "ker1x4.2");
  pridej_pw(68,  30, 21, "ker1x4.3");

  pol[2][4] = newpol("Mapa2x4", "Plocha2x4", 2,0,1,40);
  pol[2][4]->odchfunc = opravvodu;
  pridej_pw(15, 10, 96, "strom2x4");
  pridej_ps(&strom);
  pridej_ps(&voda);

  pol[3][4] = newpol("Mapa3x4", "Plocha3x4", 2,0,1,40);
  pol[3][4]->odchfunc = opravvodu;
  pridej_ps(&voda);

  pol[4][4] = newpol("Mapa4x4", "Plocha4x4", 2,0,1,40);
  pridej_ps(&voda);

  pol[5][4] = newpol("Mapa5x4", "Plocha5x4", 2,0,1,40);
  pol[5][4]->odchfunc = opravvodu;
  pridej_ps(&voda);

  pol[6][4] = newpol("Mapa6x4", "Plocha6x4", 2,0,1,40);
  pol[6][4]->odchfunc = opravvodu;
  pridej_pw(122, 47, 38, "tyc6x4");
  pridej_ps(&voda);

  pol[7][4] = newpol("Mapa7x4", "Plocha7x4", 2,0,1,40);
  pridej_ps(&voda);

  pol[0][5] = newpol("Mapa0x5", "Plocha0x5", 2,0,1,40);
  pridej_pw(40, 29, 28, "ker0x5.1");
  pridej_pw(61, 67, 66, "ker0x5.2");
  pridej_pw(81, 93, 96, "ker0x5.3");

  pol[1][5] = newpol("Mapa1x5", "Plocha1x5", 2,0,1,40);
  pridej_pw(116, 5, 56, "strom1x5");
  pridej_ps(&strom);

  pol[2][5] = newpol("Mapa2x5", "Plocha2x5", 2,0,1,40);
  pol[2][5]->odchfunc = opravvodu;
  pridej_ps(&voda);

  pol[3][5] = newpol("Mapa3x5", "Plocha3x5", 2,0,1,40);
  pol[3][5]->odchfunc = opravvodu;
  pridej_ps(&voda);

  pol[4][5] = newpol("Mapa4x5", "Plocha4x5", 2,0,1,40);
  pridej_pw(12,  8, 200, "palmlist");
  pridej_pw(59, 35,  98, "palmkmen");
  pridejbarvu("#662B00", 0)->prichfunc = padejkokos;

  pol[5][5] = newpol("Mapa5x5", "Plocha5x5", 2,0,1,40);

  pol[6][5] = newpol("Mapa6x5", "Plocha6x5", 2,0,1,40);

  pol[7][5] = newpol("Mapa7x5", "Plocha7x5", 2,0,1,40);
  pridej_pw(68, 86, 79, "balvan7x5");

  pol[0][6] = newpol("Mapa0x6", "Plocha0x6", 2,0,1,40);
  pridej_pw( 32,  46,  87, "studanka1-1");
  pridej_pw( 62,  46,  76, "studanka1-2");
  pridej_pw(120,  43,  84, "studanka2-1");
  pridej_pw(153,  43,  73, "studanka2-2");
  pridej_pw( 50, 128, 200, "skala0x6");
  pridej_ps(&voda);

  pol[1][6] = newpol("Mapa1x6", "Plocha1x6", 2,0,1,40);
  pol[1][6]->odchfunc = opravvodu;
  pridej_ps(&voda);

  pol[2][6] = newpol("Mapa2x6", "Plocha2x6", 2,0,1,40);
  pol[2][6]->odchfunc = opravvodu;
  pridej_ps(&voda);

  pol[3][6] = newpol("Mapa3x6", "Plocha3x6", 2,0,1,40);
  pol[3][6]->prichfunc = start_jp;
  pridej_pw(107,  56,  30, "trava3x6");
  pridej_pw(147, 128, 102, "trava7");
  pridej_pw(160,  99,  73, "trava4");
  pridej_pw(153,  67,  41, "trava2");
      pw_xy( 34, 122);
  pridej_pw( 67,  57,  31, "trava6x1.2");
      pw_xy(105, 134);
      pw_xy( 16,  96);
      pw_xy( 37,  66);
      pw_xy( 72, 130);

  pol[4][6] = newpol("Mapa4x6", "Plocha4x6", 2,0,1,40);

  pol[5][6] = newpol("Mapa5x6", "Plocha5x6", 2,0,1,40);

  pol[6][6] = newpol("Mapa6x6", "Plocha6x6", 2,0,1,40);
  pol[6][6]->prichfunc = start_jp;
  pridej_pw(9, 34, 10, "zaplot6x6");
  pridej_pw(42, 0, 48, "palac6x6");
  pridej_pw(160, 76, 104, "znacka6x6");
  pridej_pw(8, 131, 112, "prplot6x6");
  kq_color *vzadu;
  vzadu = pridejbarvu("#00C837", 0);
  vzadu->prichfunc = nuluj_z;
  vzadu->odchfunc = normal_z;

  pol[7][6] = newpol("Mapa7x6", "Plocha7x6", 2,0,1,40);
  pridej_pw(37, 12, 200, "strom7x6");  
  pridej_ps(&strom);
  pridej_ps(&voda);

  spojpol((kq_policko **)pol, 8,7,1,1);

  skala1 = newpol("skala1", "skala1", 2,0,1,40);
    pridej_pw(33,  49, -2, "skala1_1");
    pridej_pw( 0, 109,  0, "skala1_2");
  skala2 = newpol("skala2", "skala2", 2,0,1,40);
    pridej_pw(0,  0,  0, "skala2_1");
    pw_pix("plam5");
    pw_pix("plam4");
    pw_pix("plam3");
    pw_pix("plam2");
    pw_pix("plam1");
    pw_anim( 96, 24,  1, 0, 0, 1, 4, 2, 4, 3, 4, 4, 4, 5, 4, -1); 
    pw_anim(107, 24,  1, 0, 0, 2, 4, 3, 4, 4, 4, 5, 4, 1, 4, -1); 
    pw_anim(115, 25,  2, 0, 0, 3, 4, 4, 4, 5, 4, 1, 4, 2, 4, -1); 
    pw_anim(128, 24,  1, 0, 0, 4, 4, 5, 4, 1, 4, 2, 4, 3, 4, -1); 
    pw_anim(140, 25,  2, 0, 0, 5, 4, 1, 4, 2, 4, 3, 4, 4, 4, -1); 
    pw_anim(136, 29,  6, 0, 0, 1, 4, 2, 4, 3, 4, 4, 4, 5, 4, -1); 
    pw_anim(124, 29,  6, 0, 0, 2, 4, 3, 4, 4, 4, 5, 4, 1, 4, -1); 
    pw_anim(109, 29,  6, 0, 0, 3, 4, 4, 4, 5, 4, 1, 4, 2, 4, -1); 
    pw_anim( 99, 28,  5, 0, 0, 4, 4, 5, 4, 1, 4, 2, 4, 3, 4, -1); 
    pw_anim( 88, 28,  5, 0, 0, 5, 4, 1, 4, 2, 4, 3, 4, 4, 4, -1); 
    pw_anim(130, 32,  9, 0, 0, 1, 4, 2, 4, 3, 4, 4, 4, 5, 4, -1); 
    pw_anim(117, 33, 10, 0, 0, 2, 4, 3, 4, 4, 4, 5, 4, 1, 4, -1); 
    pw_anim(103, 33, 10, 0, 0, 3, 4, 4, 4, 5, 4, 1, 4, 2, 4, -1); 
    pw_anim( 92, 31,  8, 0, 0, 4, 4, 5, 4, 1, 4, 2, 4, 3, 4, -1); 
    pw_anim( 82, 31,  8, 0, 0, 5, 4, 1, 4, 2, 4, 3, 4, 4, 4, -1); 
    pw_anim( 94, 36, 13, 0, 0, 1, 4, 2, 4, 3, 4, 4, 4, 5, 4, -1); 
    pw_anim( 72, 30,  7, 0, 0, 2, 4, 3, 4, 4, 4, 5, 4, 1, 4, -1); 
    pw_anim( 86, 34, 11, 0, 0, 3, 4, 4, 4, 5, 4, 1, 4, 2, 4, -1); 
    pw_anim( 76, 32,  9, 0, 0, 4, 4, 5, 4, 1, 4, 2, 4, 3, 4, -1); 
  skala3 = newpol("skala3", "skala3", 2,0,1,40);
    pridej_pw(  0,  43,  0, "skala3_1");
    pridej_pw(163, 138, 105, "tyc_sk3");
        pw_xy(183, 136);
    pw_pix("plam5");
    pw_pix("plam4");
    pw_pix("plam3");
    pw_pix("plam2");
    pw_pix("plam1");
    pw_anim( 66,  27,   4, 0, 0, 1,  4, 2, 12, 3, 12, 4, 12, 5, 12, 1, 8, -1); 
    pw_anim( 58,  28,   5, 0, 0, 2,  8, 3, 12, 4, 12, 5, 12, 1, 12, 2, 4, -1); 
    pw_anim( 75,  28,   5, 0, 0, 3, 12, 4, 12, 5, 12, 1, 12, 2, 12, -1); 
    pw_anim( 42,  29,   6, 0, 0, 4,  4, 5, 12, 1, 12, 2, 12, 3, 12, 4, 8, -1); 
    pw_anim( 34,  31,   8, 0, 0, 5,  8, 1, 12, 2, 12, 3, 12, 4, 12, 5, 4, -1); 
    pw_anim( 28,  32,   9, 0, 0, 1, 12, 2, 12, 3, 12, 4, 12, 5, 12, -1); 
    pw_anim( 30,  32,   9, 0, 0, 2,  4, 3, 12, 4, 12, 5, 12, 1, 12, 2, 8, -1); 
    pw_anim( 83,  29,   6, 0, 0, 3,  8, 4, 12, 5, 12, 1, 12, 2, 12, 3, 4, -1); 
    pw_anim( 91,  30,   7, 0, 0, 4, 12, 5, 12, 1, 12, 2, 12, 3, 12, -1); 
    pw_anim( 99,  29,   6, 0, 0, 5,  4, 1, 12, 2, 12, 3, 12, 4, 12, 5, 8, -1); 
    pw_anim(105,  31,   8, 0, 0, 1,  8, 2, 12, 3, 12, 4, 12, 5, 12, 1, 4, -1); 
    pw_anim(113,  32,   9, 0, 0, 2, 12, 3, 12, 4, 12, 5, 12, 1, 12, -1); 
    pw_anim(121,  34,  11, 0, 0, 3,  4, 4, 12, 5, 12, 1, 12, 2, 12, 3, 8, -1); 
    pw_anim(129,  36,  13, 0, 0, 4,  8, 5, 12, 1, 12, 2, 12, 3, 12, 4, 4, -1); 
    pw_anim(137,  38,  15, 0, 0, 5, 12, 1, 12, 2, 12, 3, 12, 4, 12, -1); 
    pw_anim(145,  43,  20, 0, 0, 1,  4, 2, 12, 3, 12, 4, 12, 5, 12, 1, 8, -1); 
    pw_anim(149,  48,  25, 0, 0, 2,  8, 3, 12, 4, 12, 5, 12, 1, 12, 2, 4, -1); 
    pw_anim(156,  52,  29, 0, 0, 3, 12, 4, 12, 5, 12, 1, 12, 2, 12, -1); 
    pw_anim(163,  58,  35, 0, 0, 4,  4, 5, 12, 1, 12, 2, 12, 3, 12, 4, 8, -1); 
    pw_anim(168,  65,  42, 0, 0, 5,  8, 1, 12, 2, 12, 3, 12, 4, 12, 5, 4, -1); 
    pw_anim(171,  72,  49, 0, 0, 1, 12, 2, 12, 3, 12, 4, 12, 5, 12, -1); 
    pw_anim(175,  79,  56, 0, 0, 2,  4, 3, 12, 4, 12, 5, 12, 1, 12, 2, 8, -1); 
    pw_anim(179,  85,  62, 0, 0, 3,  8, 4, 12, 5, 12, 1, 12, 2, 12, 3, 4, -1); 
    pw_anim( 24,  34,  11, 0, 0, 4, 12, 5, 12, 1, 12, 2, 12, 3, 12, -1); 
    pw_anim( 32,  35,  12, 0, 0, 5,  4, 1, 12, 2, 12, 3, 12, 4, 12, 5, 8, -1); 
    pw_anim( 39,  33,  10, 0, 0, 1,  8, 2, 12, 3, 12, 4, 12, 5, 12, 1, 4, -1); 
    pw_anim( 47,  31,   8, 0, 0, 2, 12, 3, 12, 4, 12, 5, 12, 1, 12, -1); 
    pw_anim( 55,  31,   8, 0, 0, 3,  4, 4, 12, 5, 12, 1, 12, 2, 12, 3, 8, -1); 
    pw_anim( 63,  30,   7, 0, 0, 4,  8, 5, 12, 1, 12, 2, 12, 3, 12, 4, 4, -1); 
    pw_anim( 71,  31,   8, 0, 0, 5, 12, 1, 12, 2, 12, 3, 12, 4, 12, -1); 
    pw_anim( 78,  33,  10, 0, 0, 1,  4, 2, 12, 3, 12, 4, 12, 5, 12, 1, 8, -1); 
    pw_anim( 87,  34,  11, 0, 0, 2,  8, 3, 12, 4, 12, 5, 12, 1, 12, 2, 4, -1); 
    pw_anim( 95,  33,  10, 0, 0, 3, 12, 4, 12, 5, 12, 1, 12, 2, 12, -1); 
    pw_anim(102,  34,  11, 0, 0, 4,  4, 5, 12, 1, 12, 2, 12, 3, 12, 4, 8, -1); 
    pw_anim(110,  36,  13, 0, 0, 5,  8, 1, 12, 2, 12, 3, 12, 4, 12, 5, 4, -1); 
    pw_anim(117,  37,  14, 0, 0, 1, 12, 2, 12, 3, 12, 4, 12, 5, 12, -1); 
    pw_anim(125,  38,  15, 0, 0, 2,  4, 3, 12, 4, 12, 5, 12, 1, 12, 2, 8, -1); 
    pw_anim(133,  41,  18, 0, 0, 3,  8, 4, 12, 5, 12, 1, 12, 2, 12, 3, 4, -1); 
    pw_anim(140,  44,  21, 0, 0, 4, 12, 5, 12, 1, 12, 2, 12, 3, 12, -1); 
    pw_anim(146,  52,  29, 0, 0, 5,  4, 1, 12, 2, 12, 3, 12, 4, 12, 5, 8, -1); 
    pw_anim(153,  56,  33, 0, 0, 1,  8, 2, 12, 3, 12, 4, 12, 5, 12, 1, 4, -1); 
    pw_anim(159,  61,  38, 0, 0, 2, 12, 3, 12, 4, 12, 5, 12, 1, 12, -1); 
    pw_anim(164,  68,  45, 0, 0, 3,  4, 4, 12, 5, 12, 1, 12, 2, 12, 3, 8, -1); 
    pw_anim(168,  76,  53, 0, 0, 4,  8, 5, 12, 1, 12, 2, 12, 3, 12, 4, 4, -1); 
    pw_anim(172,  84,  61, 0, 0, 5, 12, 1, 12, 2, 12, 3, 12, 4, 12, -1); 
    pw_anim( 30,  38,  15, 0, 0, 1,  4, 2, 12, 3, 12, 4, 12, 5, 12, 1, 8, -1); 
    pw_anim( 41,  39,  16, 0, 0, 2,  8, 3, 12, 4, 12, 5, 12, 1, 12, 2, 4, -1); 
    pw_anim( 37,  43,  20, 0, 0, 3, 12, 4, 12, 5, 12, 1, 12, 2, 12, -1); 
    pw_anim( 46,  45,  22, 0, 0, 4,  4, 5, 12, 1, 12, 2, 12, 3, 12, 4, 8, -1); 
    pw_anim( 43,  48,  25, 0, 0, 5,  8, 1, 12, 2, 12, 3, 12, 4, 12, 5, 4, -1); 
    pw_anim( 51,  51,  28, 0, 0, 1, 12, 2, 12, 3, 12, 4, 12, 5, 12, -1); 
    pw_anim( 48,  54,  31, 0, 0, 2,  4, 3, 12, 4, 12, 5, 12, 1, 12, 2, 8, -1); 
    pw_anim( 56,  52,  29, 0, 0, 3,  8, 4, 12, 5, 12, 1, 12, 2, 12, 3, 4, -1); 
    pw_anim( 54,  56,  33, 0, 0, 4, 12, 5, 12, 1, 12, 2, 12, 3, 12, -1); 
    pw_anim( 62,  57,  34, 0, 0, 5,  4, 1, 12, 2, 12, 3, 12, 4, 12, 5, 8, -1); 
    pw_anim( 59,  59,  36, 0, 0, 1,  8, 2, 12, 3, 12, 4, 12, 5, 12, 1, 4, -1); 
    pw_anim( 68,  60,  37, 0, 0, 2, 12, 3, 12, 4, 12, 5, 12, 1, 12, -1); 
    pw_anim( 64,  62,  39, 0, 0, 3,  4, 4, 12, 5, 12, 1, 12, 2, 12, 3, 8, -1); 
    pw_anim( 73,  63,  40, 0, 0, 4,  8, 5, 12, 1, 12, 2, 12, 3, 12, 4, 4, -1); 
    pw_anim( 69,  67,  44, 0, 0, 5, 12, 1, 12, 2, 12, 3, 12, 4, 12, -1); 
    pw_anim( 78,  68,  45, 0, 0, 1,  4, 2, 12, 3, 12, 4, 12, 5, 12, 1, 8, -1); 
    pw_anim( 74,  71,  48, 0, 0, 2,  8, 3, 12, 4, 12, 5, 12, 1, 12, 2, 4, -1); 
    pw_anim( 82,  72,  49, 0, 0, 3, 12, 4, 12, 5, 12, 1, 12, 2, 12, -1); 
    pw_anim( 77,  75,  52, 0, 0, 4,  4, 5, 12, 1, 12, 2, 12, 3, 12, 4, 8, -1); 
    pw_anim( 87,  77,  54, 0, 0, 5,  8, 1, 12, 2, 12, 3, 12, 4, 12, 5, 4, -1); 
    pw_anim( 82,  80,  57, 0, 0, 1, 12, 2, 12, 3, 12, 4, 12, 5, 12, -1); 
    pw_anim( 90,  81,  58, 0, 0, 2,  4, 3, 12, 4, 12, 5, 12, 1, 12, 2, 8, -1); 
    pw_anim( 86,  84,  61, 0, 0, 3,  8, 4, 12, 5, 12, 1, 12, 2, 12, 3, 4, -1); 
    pw_anim( 95,  85,  62, 0, 0, 4, 12, 5, 12, 1, 12, 2, 12, 3, 12, -1); 
    pw_anim( 90,  89,  66, 0, 0, 5,  4, 1, 12, 2, 12, 3, 12, 4, 12, 5, 8, -1); 
    pw_anim( 99,  89,  66, 0, 0, 1,  8, 2, 12, 3, 12, 4, 12, 5, 12, 1, 4, -1); 
    pw_anim( 94,  93,  70, 0, 0, 2, 12, 3, 12, 4, 12, 5, 12, 1, 12, -1); 
    pw_anim(103,  93,  70, 0, 0, 3,  4, 4, 12, 5, 12, 1, 12, 2, 12, 3, 8, -1); 
    pw_anim( 98,  98,  75, 0, 0, 4,  8, 5, 12, 1, 12, 2, 12, 3, 12, 4, 4, -1); 
    pw_anim(107,  97,  74, 0, 0, 5, 12, 1, 12, 2, 12, 3, 12, 4, 12, -1); 
    pw_anim(103, 103,  80, 0, 0, 1,  4, 2, 12, 3, 12, 4, 12, 5, 12, 1, 8, -1); 
    pw_anim(111, 103,  80, 0, 0, 2,  8, 3, 12, 4, 12, 5, 12, 1, 12, 2, 4, -1); 
    pw_anim(108, 110,  87, 0, 0, 3, 12, 4, 12, 5, 12, 1, 12, 2, 12, -1); 
    pw_anim(114, 110,  87, 0, 0, 4,  4, 5, 12, 1, 12, 2, 12, 3, 12, 4, 8, -1); 
    pw_anim(106, 116,  93, 0, 0, 5,  8, 1, 12, 2, 12, 3, 12, 4, 12, 5, 4, -1); 
    pw_anim(114, 116,  93, 0, 0, 1, 12, 2, 12, 3, 12, 4, 12, 5, 12, -1); 
    pw_anim(110, 122,  99, 0, 0, 2,  4, 3, 12, 4, 12, 5, 12, 1, 12, 2, 8, -1); 
    pw_anim(119, 122,  99, 0, 0, 3,  8, 4, 12, 5, 12, 1, 12, 2, 12, 3, 4, -1); 
    pw_anim(107, 131, 108, 0, 0, 4, 12, 5, 12, 1, 12, 2, 12, 3, 12, -1); 
    pw_anim(114, 128, 105, 0, 0, 5,  4, 1, 12, 2, 12, 3, 12, 4, 12, 5, 8, -1); 
    pw_anim(123, 128, 105, 0, 0, 1,  8, 2, 12, 3, 12, 4, 12, 5, 12, 1, 4, -1); 
    pw_anim(130, 128, 105, 0, 0, 2, 12, 3, 12, 4, 12, 5, 12, 1, 12, -1); 
    pw_anim(137, 129, 106, 0, 0, 3,  4, 4, 12, 5, 12, 1, 12, 2, 12, 3, 8, -1); 
    pw_anim(144, 131, 108, 0, 0, 4,  8, 5, 12, 1, 12, 2, 12, 3, 12, 4, 4, -1); 
    pw_anim(151, 130, 107, 0, 0, 5, 12, 1, 12, 2, 12, 3, 12, 4, 12, -1); 
    pw_anim(125, 133, 110, 0, 0, 1,  4, 2, 12, 3, 12, 4, 12, 5, 12, 1, 8, -1); 
    pw_anim(133, 135, 112, 0, 0, 2,  8, 3, 12, 4, 12, 5, 12, 1, 12, 2, 4, -1); 
    pw_anim(140, 133, 110, 0, 0, 3, 12, 4, 12, 5, 12, 1, 12, 2, 12, -1); 
    pw_anim(147, 135, 112, 0, 0, 4,  4, 5, 12, 1, 12, 2, 12, 3, 12, 4, 8, -1); 
    pw_anim(122, 139, 116, 0, 0, 5,  8, 1, 12, 2, 12, 3, 12, 4, 12, 5, 4, -1); 
    pw_anim(129, 141, 118, 0, 0, 1, 12, 2, 12, 3, 12, 4, 12, 5, 12, -1); 
    pw_anim(137, 139, 116, 0, 0, 2,  4, 3, 12, 4, 12, 5, 12, 1, 12, 2, 8, -1); 
    pw_anim(144, 139, 116, 0, 0, 3,  8, 4, 12, 5, 12, 1, 12, 2, 12, 3, 4, -1); 
    pw_anim(117, 135, 112, 0, 0, 4, 12, 5, 12, 1, 12, 2, 12, 3, 12, -1); 
    pw_anim(109, 137, 114, 0, 0, 5,  4, 1, 12, 2, 12, 3, 12, 4, 12, 5, 8, -1); 
    pw_anim(116, 140, 117, 0, 0, 1,  8, 2, 12, 3, 12, 4, 12, 5, 12, 1, 4, -1); 
    pw_anim(105, 139, 115, 0, 0, 2, 12, 3, 12, 4, 12, 5, 12, 1, 12, -1); 
    pw_anim(111, 145, 122, 0, 0, 3,  4, 4, 12, 5, 12, 1, 12, 2, 12, 3, 8, -1); 
    pw_anim(120, 144, 121, 0, 0, 4,  8, 5, 12, 1, 12, 2, 12, 3, 12, 4, 4, -1); 
    pw_anim(133, 143, 120, 0, 0, 5, 12, 1, 12, 2, 12, 3, 12, 4, 12, -1); 
    pw_anim(141, 145, 122, 0, 0, 1,  4, 2, 12, 3, 12, 4, 12, 5, 12, 1, 8, -1); 
    pw_anim(101, 144, 121, 0, 0, 2,  8, 3, 12, 4, 12, 5, 12, 1, 12, 2, 4, -1);
    pw_anim( 44,  43,  20, 0, 0, 3, 12, 4, 12, 5, 12, 1, 12, 2, 12, -1); 
  skala1->vedle[VPRAVO] = skala2;
  skala2->vedle[VLEVO] = skala1;
  skala2->vedle[NAHORU] = skala3;
  skala3->vedle[DOLU] = skala2;

  skal_zebr1 = newpol("skal_zebr1", "skal_zebr", 2, 62, 1,35);
  skal_zebr1->prichfunc = prichzebr;
  skal_zebr1->odchfunc = odchzebr;
  skal_zebr2 = newpol("skal_zebr2", "skal_zebr", 2, 62, 1,35);
  skal_zebr2->prichfunc = prichzebr;
  skal_zebr2->odchfunc = odchzebr;

  pol[0][1]->vedle[NAHORU] = skal_zebr1;
  skal_zebr1->vedle[DOLU]   = pol[0][1];
  skal_zebr1->vedle[NAHORU] = skal_zebr2;
  skal_zebr2->vedle[DOLU]   = skal_zebr1;
  skal_zebr2->vedle[NAHORU] = skala3;

  vdrevchal = newpol("vdrevchal", "vdrevchal", 2, 0, 1, 40);
  vdrevchal->odchfunc = zdrchal;
  vdrevchal->vedle[DOLU] = pol[5][1];
  pridej_pw( 67, 64,   60, "stul");
  pridej_pw(  0,  3,  200, "vdrevchal_fg");
  pridej_pw(109, 36,   28, "zidle");
  pridej_pw( 77, 38,   31, "zidle2");

  lvi = newpol("lvi", "lvi", 2, 0, 1, 34);
  pridejbarvu("#6B3500", 0)->prichfunc = levchyt;
  pridej_pw(  6, 67,  62, "lev1");
  pridej_pw( 76, 66,  62, "lev2");
  pridej_pw(  0, 95, 200, "lvi_fg");

  peklbrana = newpol("peklbrana", "peklbrana", 2, 0, 1, 112);
  pridej_pw( 0, 95, 200, "lvi_fg");

  peklo = newpol("peklo", "peklo", 2, 0, 1, 60);
  peklo->prichfunc = prich_peklo;
  peklo->odchfunc = opravschody;
  pridej_pw(33, 40,  18, "vidle");
  pridej_pw(66,  0,  55, "kotel");
  pridej_pw( 0,  0, 200, "peklo_fg");

  schody1 = newpol("schody1", "schody1", 2, 40, 1, 30);
  schody1->odchfunc = opravschody;
  pridej_pw(43, 35, 0, "schody1");

  schody2 = newpol("schody2", "schody2", 2,  0, 1, 30);
  schody2->odchfunc = opravschody;
  pridej_pw(0, 38,  -2, "schody2.1");
  pridej_pw(0, 83,   0, "schody2.2");
  pridej_pw(0,  0, 200, "schody2_fg");

  peklbrana->vedle[NAHORU] = peklo;
  peklo->vedle[DOLU] = peklbrana;
  peklo->vedle[NAHORU] = schody1;
  schody1->vedle[DOLU] = peklo;
  schody1->vedle[VPRAVO] = schody2;
  schody2->vedle[VLEVO] = schody1;

  vzamku1 = newpol("vzamku1", "vzamku1", 2, 0, 1, 90);
  pridej_pw(0, 0, 200, "vzamku1_fg");

  vzamku2 = newpol("vzamku2", "vzamku2", 2, 0, 1, 90);
  pridejbarvu("#00FFFF", 0)->prichfunc = predTV;
  pridej_pw( 0,   0, 200, "vzamku2_fg");
  pridej_pw(80, 120,  63, "televize");
  pridej_pw(60,  67,  16, "kral");
  pridej_ps(&kral);
  pridej_ps(&muz);
  pridej_ps(&osoba);

  vzamku1->vedle[DOLU] = pol[4][3];
  vzamku1->odchfunc = odch_hrad;
  vzamku1->vedle[VLEVO] = vzamku2;
  vzamku2->vedle[VPRAVO] = vzamku1;
}

void nullujznak (kq_policko *opol, int smer, kq_policko **npol, int *x, int *y)
{
  znak = 0;
}

void opravvodu (kq_policko *opol, int smer, kq_policko **npol, int *x, int *y)
{
  int ol, op, nl, np, ns;

  if(*npol == pol[0][3]){
    if(smer == NAHORU){
      ol = 15;
      op = 33;
      nl = 1;
      np = 47;
      ns = 28;
    }
    else if(smer == DOLU){
      ol = 8;
      op = 41;
      nl = 12;
      np = 41;
      ns = 24;
    }
    else return;
  }
  else if(opol == pol[0][3]){
    if(smer == NAHORU){
      ol = 17;
      op = 36;
      nl = 3;
      np = 46;
      ns = 20;
    }
    else if(smer == DOLU){
      ol = 6;
      op = 42;
      nl = 10;
      np = 38;
      ns = 255;
    }
    else return;
  }
  else if(*npol == pol[2][3]){
    if(smer == NAHORU){
      ol = 63;
      op = 80;
      nl = 38;
      np = 83;
      ns = 61;
    }
    else if(smer == DOLU){
      ol = 54;
      op = 80;
      nl = 59;
      np = 85;
      ns = 72;
    }
    else return;
  }
  else if(opol == pol[2][3]){
    if(smer == NAHORU){
      ol = 64;
      op = 80;
      nl = 49;
      np = 85;
      ns = 68;
    }
    else if(smer == DOLU){
      ol = 43;
      op = 78;
      nl = 58;
      np = 85;
      ns = 71;
    }
    else return;
  }
  else if(*npol == pol[5][3]){
    if(smer == NAHORU){
      ol = 58;
      op = 78;
      nl = 43;
      np = 94;
      ns = 61;
    }
    else if(smer == DOLU){
      ol = 35;
      op = 97;
      nl = 44;
      np = 85;
      ns = 68;
    }
    else return;
  }
  else if(opol == pol[5][3]){
    if(smer == NAHORU){
      ol = 49;
      op = 80;
      nl = 30;
      np = 102;
      ns = 83;
    }
    else if(smer == DOLU){
      ol = 48;
      op = 89;
      nl = 53;
      np = 83;
      ns = 67;
    }
    else return;
  }
  else if(*npol == pol[6][3]){
    if(smer == NAHORU){
      ol = 36;
      op = 50;
      nl = 24;
      np = 62;
      ns = 42;
    }
    else if(smer == DOLU){
      ol = 61;
      op = 95;
      nl = 64;
      np = 91;
      ns = 78;
    }
    else return;
  }
  else if(opol == pol[6][3]){
    if(smer == NAHORU){
      ol = 69;
      op = 86;
      nl = 56;
      np = 100;
      ns = 80;
    }
    else if(smer == DOLU){
      ol = 29;
      op = 57;
      nl = 31;
      np = 55;
      ns = 42;
    }
    else return;
  }
  else if((opol == pol[3][5] && smer == NAHORU) ||
	  (opol == pol[3][4] && smer == DOLU)){
    ol = 51;
    op = 65;
    nl = 29;
    np = 56;
    ns = 0;
  }
  else if((opol == pol[2][6] && smer == NAHORU) ||
	  (opol == pol[2][5] && smer == DOLU)){
    ol = 71;
    op = 89;
    nl = 57;
    np = 91;
    ns = 0;
  }
  else if((opol == pol[1][0] && smer == NAHORU) ||
	  (opol == pol[1][6] && smer == DOLU)){
    ol = 54;
    op = 69;
    nl = 53;
    np = 72;
    ns = 0;
  }
  else return;

  if(ns){
    if(*x > ol && *x < op){
      *x = ns;
      return;
    }

    if(*x <= nl || *x >= np) return;
    if(*x <= ol) *x = nl;
    else *x = np;
  }
  else{
    if(smer == DOLU){
      ns = ol; ol = nl; nl = ns;
      ns = op; op = np; np = ns;
    }

    if(*x < ol) *x = *x * nl / ol;
    else if(*x >= op){
      ol = mapa.sirka-op;
      nl = mapa.sirka-np;
      *x -= op;
      *x = *x * nl / ol;
      *x += np;
    }
    else{
      op -= ol;
      np -= nl;
      *x -= ol;
      *x = *x * np / op;
      *x += nl;
    }
  }
}

void odchzebr (kq_policko *opol, int smer, kq_policko **npol, int *x, int *y)
{
  zebrik->slovo->kontext = 0;
  if(opol == skal_zebr2 && smer == NAHORU){
    *x = 87;
    *y = -15;
    zmenanip(panacek, chozeni);
    normal_z(panacek, NULL, NULL);
  }
  else if(opol == pol[0][1] && *npol == skal_zebr1) *x -= 66;
  else if(opol == skal_zebr1 && *npol == pol[0][1]) *x += 66;
  if(jezibaba && jezibaba->animace == jezianip){
    if(*npol == skal_zebr1) *x -= 3;
    else if(*npol == skal_zebr2) *x = 22;
    else if(*npol == pol[0][1]) *x = 88;
  }
}

void prichzebr (kq_policko *opol, int smer, kq_policko *npol)
{
  if(!zebrik->stav) return;

  zebrik->slovo->kontext = 1;
  if(npol == pol[0][1]){
    vytvorsubmap( 76, 46, 5, "spodzebr", 1, 0);
    vytvorwidget(164, 0, 49, nactikqXPM("spodzebr", 1), 1, 0);
  }
  else if(npol == skal_zebr1){
    if(jezibaba && jezibaba->animace == jezianip) houpejzebr();
    else vytvorwidget(94, 0, 0, nactikqXPM("zebrik", 1), 1, 0);
  }
}

static void vytvorcerta (int x, int y, kq_animpost *anip)
{
  kq_postava *post;

  post = vytvorpost(x, y, DOLU, 3, -1, 1, 0);
  zmenanip(post, anip);
  setchytpost(post, panacek);
  autopost(post, auto_clever, 0, 0);
  post->chyt_vzdal = 5;
  post->chyt_func = chyt_cert;
  normal_z(post, NULL, NULL);
  post->odejde = 0;
  post->odraz = 1;
}

void prich_peklo (kq_policko *npol, int smer, kq_policko *opol)
{
  kq_animpost *anip;

  peklohen = vytvorwidget(62, 93, 55.2, nactikqXPM("ohen", 1), 1, 0);
  anip = nactianip(9, 40, "cert", 4, 0, 0, 0, 1);
  vytvorcerta(41, 14, anip);
  vytvorcerta(22, 32, anip);
  vytvorcerta(78, 38, anip);
  vytvorcerta(26, 72, anip);
  vytvorcerta(83, 73, anip);
  certi->kontext = 1;
  osoba->kontext = 1;
}

void opravschody (kq_policko *opol, int smer, kq_policko **npol, int *x, int *y)
{
  certi->kontext = 0;
  osoba->kontext = 0;
  peklohen = NULL;
  if(*npol == peklbrana) return;
  if(smer == NAHORU){
    *x -= 33;
    *x *= 15;
    *x /= 22;
    *x += 1;
  }
  else if(smer == DOLU){
    *x -= 1;
    *x *= 22;
    *x /= 15;
    *x += 33;
  }
  else if(smer == VPRAVO){
    *y += 110;
  }
  else if(smer == VLEVO){
    *y -= 110;
  }
}

void chyt_cert (kq_postava *post)
{
  kq_postava *pom;

  if(!panacek){
    post->chyt_func = NULL;
    autopost(post, auto_random, 20, 20);
    setchytsour(post, 0, 0);
    return;
  }

  znicpost(panacek);
  panacek = ovlpost = NULL;
  setchytsour(post, 54, 72);
  post->chyt_vzdal = 0;

  for(pom = prvpost; pom; pom = pom->next){
    if(pom != post){
      pom->chyt_func = NULL;
      autopost(pom, auto_random, 20, 20);
      setchytsour(pom, 0, 0);
    }
  }
  popup_info("chytil cert");
}

void odch_hrad (kq_policko *opol, int smer, kq_policko **npol, int *x, int *y)
{
  if(smer != DOLU) return;

  *x = 27;
  *y = 75;
}
