#include "version.h"
#include "kraluk.h"

static void restart ()
{
  set_pol(pol[4][3]);

  initprom();       // nastavim pocatecni hodnoty promennym
  vetyslova();      // nastavim slova a vety
  vytvorpredmety(); // zalozim predmety (kq_predmet)


  // vytvorim panacka:

  panacek = vytvorpost(22, 85, DOLU, 3, 0, 0, 0);
  zmenanip(panacek, chozeni);
  ovlpost = panacek;
  normal_z(panacek, NULL, NULL);  
}

int main (int argc, char **argv)
{
  printf("This is kraluk version %s\n", VERSION);

  kql_defaults();
  identstring = "Kralovsky ukol 1";
  setFPSs(1000.0, 700.0, 400.0, 200.0, 100.0, 70.0, -50.0, 25.0, 15.0,
	  9.0, 6.0, 3.0, 2.0, 1.5, 0.);
  kql_init(argc, argv);

  registrujpf();   // registruji promenne a funkce pro moduly save a load
  nactigbarvy();   // nastavim globalni barvy
  nactianipy();    // nactu fixovane animace postav
  nastavpolicka(); // nastavim policka (scena) hry

  kql_start(&restart);

  return 0;
}
