struct pol_widget{
  char typ;
  union{
    struct{
      int x,y;
      float z;
    } widget;
    char *pixmap;
    struct{
      float priorita;
      int opakovani;
      int pocet;
    } anim;
    struct{
      int pix1;
      int cas1;
      int pix2;
      int cas2;
    } pokranim;
  } u;
  struct pol_widget *next;
};

struct pol_submap{
  int x, y;
  float z;
  char *filename;
  char hide;
  struct kq_submap **ulozit;
  struct pol_submap *next;
};

struct pol_postava{
  int x, y;
  float xz, yz, z;

  char smer;

  char *sm_nazev;
  int sm_x, sm_y;
  float sm_z;

  char *a_nazev;
  int a_framu, a_x, a_y, a_tim, a_jednopol, a_porad;

  char hide;
  struct kq_postava **ulozit;
  struct pol_postava *next;
};

kq_color *globbarva;

struct kq_policko{
  kq_color *locbarva;
  char *jmpixmap, *jmmapa;
  int xa,xb,ya,yb;
  kq_policko *vedle[4];
  void (*odchfunc)(kq_policko *odch, int smer,
		   kq_policko **prich, int *x, int *y);
  void (*prichfunc)(kq_policko *odch, int smer,
		    kq_policko *prich);
  int pocetanim;
  struct pol_widget *pw;
  struct pol_submap *psm;
  struct pol_postava *pp;
  kq_list *ps;
  kq_predmet *predmety;

  kq_policko *next;
  unsigned int Cislo;
};

void (*pol_odchfunc)(kq_policko *odch, int smer, kq_policko **prich, int *x, int *y);
void (*pol_prichfunc)(kq_policko *odch, int smer, kq_policko *prich);

kq_policko *aktupol, *prvpol;
int pocet_pol;

kq_anim *animpole;

kq_policko *newpol(char *jmpixmap, char *jmmapa,
		       int xa, int xb, int ya, int yb);
void pw_pix(char *nazev);
void pw_wid(int x, int y, float z);
void pw_xy(int x, int y);
void pw_anim (int x, int y, float z, float priorita, int opakovani, int prvpix, int prvcas, ...);
void pridej_ps (kq_word **w);
void pridej_pw(int x,int y, float z, char *nazev);
void pridej_pp (int x, int y, char smer, char hide, kq_postava **ulozit,
		float xz, float yz, float z,
		char *sm_nazev, int sm_x, int sm_y, float sm_z,
		char *a_nazev, int a_framu, char a_x, char a_y,
		char a_tim, char a_jednopol, char a_porad);
void pridej_psm (int x,int y, float z, char *nazev, char hide, kq_submap **ulozit);

void prvnipol();
void vykreslipol();
void set_pol(kq_policko *pol);
char polvedle(kq_postava *post, int smer);
void kql_square(kq_postava *post, kq_policko *pol,
		int px, int py, int mx, int my, int vyhnout);
void spojpol(kq_policko **pole, int sirka, int vyska,
	                        int htorus, int vtorus);
void free_animpole();
